#include "adminmainwindow.h"
#include "ui_adminmainwindow.h"

AdminMainWindow::AdminMainWindow(QWidget *parent) :
    QMainWindow(parent) ,
    ui(new Ui::AdminMainWindow)
{
    ui->setupUi(this);
    this->setWindowTitle("Окно админа");
    this->show();
    m_db = QSqlDatabase::addDatabase("QPSQL");
    connectDB(m_db);
    tables_list_update();
    m_query = new QSqlQuery(m_db);
}

AdminMainWindow::~AdminMainWindow()
{
    delete ui;
}

void AdminMainWindow::tables_list_update(){
    if (!m_db.open()){
        ui->statusbar->showMessage("Error: DB not connectred");
    }
    else{
        ui->statusbar->showMessage("DB connected succesfully");
        QStringListModel *model = new QStringListModel(m_db.tables());
        ui->listView->setModel(model);
    }
}

void AdminMainWindow::on_listView_clicked(const QModelIndex &index)
{
    if (connectDB(m_db)){
    m_table_model = new QSqlTableModel(this, m_db);
    m_table_model->setTable(index.data().toString());
    m_table_model->select();
    ui->tableView->setModel(m_table_model);
    }
    else
        ui->statusbar->showMessage("Error: DB not connectred");
}

void AdminMainWindow::on_reconnect_triggered()
{
    connectDB(m_db);
}

void AdminMainWindow::on_submitButton_clicked()
{
    run_sql_query(ui->queryField->document()->toPlainText());
}

void AdminMainWindow::run_sql_query(const QString& p_query_text)
{
    ui->error_label->clear();
    m_query->exec(p_query_text);
    if (!m_query->isActive()){
        ui->error_label->setText(m_query->lastError().text());
    } else {
        qDebug() << p_query_text;
        ui->queryHistory->setPlainText(ui->queryHistory->toPlainText()+'\n'+p_query_text);
        QSqlQueryModel* result_model = new QSqlQueryModel(this);
        result_model->setQuery(*m_query);
        ui->tableView->setModel(result_model);
        tables_list_update();
    }
}

void AdminMainWindow::on_Lindun_triggered()
{
    okno = new lindun();
    okno->show();
    this->close();
}
